<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Workflow using the Xsens Awinda System</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Workflow using the Xsens Awinda System </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="s_intro"></a>
Introduction</h1>
<p>The following explains the recommended workflow when using the MTw Development Kit with XDA. The system, involving both the Awinda Master and the MTw, is known to be in certain states. Possible functionality is specifically related to a given state. The possible transitions from one state to another is limited. It is advised to understand the states and transitions of both the Awinda Master and of the MTw in order to work according to the recommended workflow as much as possible.</p>
<h1><a class="anchor" id="s_awsstates"></a>
Awinda Master states</h1>
<p>The figure below provides an overview of the states of the Awinda Master; The table describes these states and transitions with some suggestions for using XDA. </p><div class="doxyimage"> <div class="image">
<img src="diagram_awindamaster.png" alt="diagram_awindamaster.png"/>
<div class="caption">
State Diagram of Awinda Station.</div></div>
 </div><p>The following table describes these states and transitions with some suggestions for using XDA.</p>
<table class="doxtable">
<tr>
<th>State </th><th>Description </th><th>Suggested Action  </th></tr>
<tr>
<td>Connecting </td><td>Awinda Master not yet connected to XDA </td><td>Do a port scan, open port and request device instance  </td></tr>
<tr>
<td>Connected </td><td>The Master is detected. The port is open and connected to XDA.<br />
The radio of the Awinda Master is not yet transmitting. </td><td>Call <a class="el" href="struct_xs_device.html#a451ae32410afc778ef81fa3e3c7a9fe4" title="Set the radio channel to use for wireless communication. ">XsDevice::enableRadio()</a> with the required radio channel.  </td></tr>
<tr>
<td>Enabled </td><td>The radio of the Awinda Master is switched on and broadcasting on the specified channel.<br />
MTw's can detect this transmission and start to connect to the network. </td><td>Wait until all devices have joined the network.<br />
Give the <a class="el" href="struct_xs_device.html#a4539825a286248b59c66bd89cf7c1090" title="Put this device in measurement mode. ">XsDevice::gotoMeasurement()</a> command.  </td></tr>
<tr>
<td rowspan="3">Measuring </td><td rowspan="3">The MTw's are measuring and transmitting data to the Master.<br />
The Master forwards each data packet received to XDA. </td><td>Continue Measuring. </td></tr>
<tr>
<td>Return to the Config (Wireless) state to make changes to the wireless network using the <a class="el" href="struct_xs_device.html#ab2b32660f266c44ba18323d1a26b6b7e" title="Put the device in config mode. ">XsDevice::gotoConfig()</a> command. </td></tr>
<tr>
<td>Enter Recording state using the <a class="el" href="struct_xs_device.html#ab8aef28ccbb4b80b80be6b85fedd6d87" title="Start recording incoming data. ">XsDevice::startRecording()</a> command.  </td></tr>
<tr>
<td>Config (Wireless) </td><td>The Master is operational, the wireless network is established.<br />
No new MTw's can connect to the network. </td><td>Give the <a class="el" href="struct_xs_device.html#a4539825a286248b59c66bd89cf7c1090" title="Put this device in measurement mode. ">XsDevice::gotoMeasurement()</a> command to start measuring, or <a class="el" href="struct_xs_device.html#ac3614a08ca0e3d2df2f72aa9632189f6" title="Disables the radio for this station, resetting all children to disconnected state. ">XsDevice::disableRadio()</a> to switch the radio off on the Awinda Master, and return to Enabled state.  </td></tr>
<tr>
<td rowspan="2">Recording </td><td rowspan="2">Recording is in progress.<br />
A new file is created, wherein transmitted data is stored.<br />
If the maximum update rate was chosen, recorded data cannot contain retransmitted data. If a lower update rate is selected, the recording will contain retransmissions when necessary. </td><td>Continue recording. </td></tr>
<tr>
<td>Return to measurement state, using the command stopRecording.  </td></tr>
<tr>
<td rowspan="3">Flushing </td><td rowspan="3">Recording was stopped. Data still on the buffer of the MTw are retransmitted to the Awinda Master. </td><td>Wait until flushing is complete. </td></tr>
<tr>
<td>Close the logfile using <a class="el" href="struct_xs_device.html#a672a0f86279cde90b7f4441410f272cc" title="Close the log file. ">XsDevice::closeLogFile()</a>. </td></tr>
<tr>
<td>Return to Enabled state using <a class="el" href="struct_xs_device.html#ab2b32660f266c44ba18323d1a26b6b7e" title="Put the device in config mode. ">XsDevice::gotoConfig()</a>.  </td></tr>
</table>
<h1><a class="anchor" id="s_mtwstates"></a>
Mtw states</h1>
<p>The figure below provides an overview of the states of an MTw; The table describes these states and transitions with some suggestions for using XDA. </p><div class="doxyimage"> <div class="image">
<img src="diagram_mtw.png" alt="diagram_mtw.png"/>
<div class="caption">
State Diagram of MTw.</div></div>
 </div><p>The following table describes these states and transitions with some suggestions for using XDA. </p><table class="doxtable">
<tr>
<th>State </th><th>Description </th><th>Suggested Action  </th></tr>
<tr>
<td>Sleep </td><td>Power saving state to which the MTw enters if it is idle for some time. </td><td>Rotate the MTw to return to scanning state.<br />
Dock the MTw into the Awinda Station to enter Config state.  </td></tr>
<tr>
<td>Scanning </td><td>MTw scans all radio channels to find a Master in the Enabled state. </td><td>Wait until connected indications are received. (see Enabled state of the Awinda Master).  </td></tr>
<tr>
<td>Config (Wireless) </td><td>MTw is wirelessly connected to a Master but not yet measuring. </td><td>None. MTw is controlled by Master.  </td></tr>
<tr>
<td>Measuring (Wireless) </td><td>MTw is wirelessly connected to a Master and in measuring state. </td><td>None. MTw is controlled by Master.  </td></tr>
<tr>
<td rowspan="3">Config (Wired) </td><td rowspan="3">Device is docked.<br />
Configurations can be changed. (not intended use) </td><td>Configure the device. </td></tr>
<tr>
<td>Undock device to start scanning for a Master. </td></tr>
<tr>
<td>Start measurement while docked (not intended use).  </td></tr>
<tr>
<td rowspan="2">Measuring (Wired) </td><td rowspan="2">MTw is wired or docked and in measuring state </td><td>Undock device to start scanning for a Master. </td></tr>
<tr>
<td>Stop measurement while docked to enter config state.  </td></tr>
</table>
<h1><a class="anchor" id="s_workflow"></a>
Work Flow</h1>
<p>This section shows the necessary steps required to start a recording on an Awinda Master with multiple wireless MTw's and process the generated data using XDA.</p>
<ul>
<li>
Startup phase  <ol>
<li>
<p class="startli">Initialize XDA </p><div class="groupText"> The application starts with the creation of an <a class="el" href="struct_xs_control.html" title="High level Motion Tracker (MT) management class. ">XsControl</a> object using the <a class="el" href="struct_xs_control.html#a025a2b6f7542f1f731028633fab21562" title="Construct a new XsControl* object. Clean it up with the destruct() function or delete the object...">XsControl::construct</a> function. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Discover devices </p><div class="groupText"> The application detects devices available to the system using the <a class="el" href="class_xs_scanner.html#a42f1eac216fdfa16fd001264d7763202" title="Scan all ports for Xsens devices. ">XsScanner::scanPorts</a> function. This function will return all communication ports to which Xsens devices are connected. Check using <a class="el" href="struct_xs_device_id.html#ad9df4500a5aaaa2c891a20102bdfab94" title="Test if this device ID represents a Wireless Master device (Awinda Station, Awinda Dongle...">XsDeviceId::isWirelessMaster</a> for available Awinda Systems </div><p class="endli"></p>
</li>
<li>
<p class="startli">Open devices of interest </p><div class="groupText"> The port information obtained in the previous step is used to open devices of interest using the <a class="el" href="struct_xs_control.html#a0dcd5f3427b7509b07baf64650e56dbd" title="Open a communication channel on serial port with the given portname. ">XsControl::openPort</a> function. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Configure devices </p><div class="groupText"> If needed the application configures the open devices. Through the <a class="el" href="struct_xs_control.html#a1f9a3e46365b0381eb5bdecec5c66014" title="Returns the XsDevice interface object associated with the supplied deviceId. ">XsControl::device</a> function the application obtains <a class="el" href="struct_xs_device.html" title="A pointer to an XsDevice object. ">XsDevice</a> instances required to do the configuration. Typical configuration actions are setting the output data format and data rate to the desired values. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Prepare for data handling (event based) </p><div class="groupText"> With event based data handling the application is signalled with an <a class="el" href="struct_xs_data_packet.html" title="Contains an interpreted data message. The class provides easy access to the contained data through it...">XsDataPacket</a> as soon as it arrives. To enable this a callback object must be registered. The application creates an object derived from <a class="el" href="class_xs_callback.html" title="Structure that contains callback functions for the Xsens Device API. ">XsCallback</a> that overrides the <a class="el" href="group___callbacks.html#gaf94a5a76c3a443255fc53f7a2bf9e076" title="Called when new data has been received from a device or read from a file. When processing on PC is en...">XsCallback::onLiveDataAvailable</a> function. The object is registered with XDA using the <a class="el" href="struct_xs_control.html#a189065247d7fb3758a355c403c68866d" title="Add a callback handler to the list. ">XsControl::addCallbackHandler</a> function. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Configure Awinda Master </p><div class="groupText"> Set the desired update rate using <a class="el" href="struct_xs_device.html#a3c0da43d5b8efb0e99b724bd999a9459" title="Set the legacy update rate of the device. ">XsDevice::setUpdateRate</a> </div><p class="endli"></p>
</li>
<li>
<p class="startli">Enable the radio </p><div class="groupText"> Set the radio channel and enable the radio. The available channels are 11 to 26. When expecting interference with WIFI devices, try Channels 15 and 20 or 25 and 26, see MTw User Manual for more information.<br />
 When the radio is enabled, MTw's can wirelessly connect to the Master. Undock the required MTw's and wait for a connection to be established. When an MTw connects, the <a class="el" href="group___callbacks.html#gacad6280b5dc0c8e458b22e26a50bad40" title="Called when XDA has detected a change in the connectivity state of a device. ">XsCallback::onConnectivityChanged</a> callback is called, which provides the MTw's <a class="el" href="struct_xs_device.html" title="A pointer to an XsDevice object. ">XsDevice</a> instance and the new XsConnectivityState, which should be XCS_Wireless.<br />
 <a class="el" href="struct_xs_device.html" title="A pointer to an XsDevice object. ">XsDevice</a> instances of connected MTw's are not yet fully functional at this stage. When the MTw's are in measurement mode, the full functionality will be available. When all MTw's are connected, the measurement can be started. Use the <a class="el" href="struct_xs_device.html" title="A pointer to an XsDevice object. ">XsDevice</a> instance of the Master to put the Master and all wirelessly connected MTw's into measurement mode. </div><p class="endli"></p>
</li>
<li>
<p class="startli">Switch devices to measurement mode </p><div class="groupText"> The devices are set to measurement mode. The application can do this either per <b>main</b> device with the <a class="el" href="struct_xs_device.html#a4539825a286248b59c66bd89cf7c1090" title="Put this device in measurement mode. ">XsDevice::gotoMeasurement</a> function or for all devices simultaneously using XsControl::gotoMeasurement </div><p class="endli"></p>
</li>
</ol>
</li>
<li>
Processing phase  <ol>
<li>
<p class="startli">Handle incoming data </p><div class="groupText"> The onPostProcess function of the callback object registered in the startup phase will be called whenever new data is available. The function gets a pointer to the newly available <a class="el" href="struct_xs_data_packet.html" title="Contains an interpreted data message. The class provides easy access to the contained data through it...">XsDataPacket</a> as parameter. The <a class="el" href="struct_xs_data_packet.html#af6df84de7bcdaae218021b627847a165" title="Return the device ID associated with the data packet. ">XsDataPacket::deviceId</a> function is used to determine from which device the packet is received. Refer to <a class="el" href="overview.html#s_concurrency">Concurrency</a> for a more indepth view on event based data handling </div><p class="endli"></p>
</li>
<li>
<p class="startli">Check for completion </p><div class="groupText"> The application checks the conditions required for process completion, these are application defined. If the conditions are met the Exit phase is entered </div><p class="endli"></p>
</li>
</ol>
</li>
<li>
Exit phase  <ol>
<li>
<p class="startli">Close open devices </p><div class="groupText"> All open devices are closed. The application uses the <a class="el" href="struct_xs_control.html#a9b3617d4a55cf48ddf7257788e1d5a79" title="Close the serial port with the given portname. ">XsControl::closePort</a> function on each openend device to do this or the Xscontrol::close function to close all open devices. Closing the device will automatically change the state of the device from measurement mode to config mode. </div><p class="endli"></p>
</li>
<li>
Clean up XDA <div class="groupText"> The application releases the <a class="el" href="struct_xs_control.html" title="High level Motion Tracker (MT) management class. ">XsControl</a> object created at startup using the <a class="el" href="struct_xs_control.html#a383124de0bf073f72800eb1905008eee" title="Destruct a XsControl object and free all memory allocated for it. ">XsControl::destruct</a> function. </div> </li>
</ol>
</li>
</ul>
</div></div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Thu Jun 29 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
